Menu

- Learn
- Documentation
  - Language Reference
  - Library Reference
  - Command-line Reference
  - Feature Overview
  - Articles
- Downloads
- Packages
- Community
  - Blog
  - Orgs using D
  - Twitter
  - Calendar
  - Forums
  - IRC
  - Wiki
  - GitHub
  - Issues
  - Get involved
  - Contributors
  - Foundation
  - Security Team
  - Donate
  - Sponsors
- Resources
  - Tour
  - Books
  - Tutorials
  - Tools
  - Editors
  - IDEs
  - run.dlang.io
  - Visual D
  - Acknowledgments
  - D Style
  - Glossary
  - Sitemap

Search
Report a bug
If you spot a problem with this page, click here to create a Bugzilla issue.
Improve this page
Quickly fork, edit online, and submit a pull request for this page. Requires a signed-in GitHub account. This works well for small changes. If you'd like to make larger changes you may want to consider using a local clone.

# dmd.ctorflow

Compiler implementation of the D programming language.
Manage flow analysis for constructors.
Authors:
Walter Bright
License:
Boost License 1.0

Source ctorflow.d

Documentation https://dlang.org/phobos/dmd_ctorflow.html

Coverage https://codecov.io/gh/dlang/dmd/src/master/src/dmd/ctorflow.d

struct `FieldInit`;
  Individual field in the Ctor with information about its callees and location.
  CSX `csx`;
    information about the field's callees
  Loc `loc`;
    location of the field initialization
struct `CtorFlow`;
  Primitive flow analysis for constructors
  CSX `callSuper`;
    state of calling other constructors
  FieldInit[] `fieldinit`;
    state of field initializations
  CtorFlow `clone`();
    Create a deep copy of this
    Returns:
    a copy
  pure nothrow void `orCSX`(CSX `csx`);
    Set CSX bits in flow analysis state
    Parameters:

    CSX `csx` | bits to set

  pure nothrow void `OR`(ref const CtorFlow `ctorflow`);
    OR CSX bits to this
    Parameters:

    CtorFlow `ctorflow` | bits to OR in

pure nothrow bool `mergeCallSuper`(ref CSX `a`, const CSX `b`);
  Merge `b` flow analysis results into `a`.
  Parameters:

  CSX `a` | the path to merge `b` into
  CSX `b` | the other path

  Returns:
  false means one of the paths skips construction
pure nothrow bool `mergeFieldInit`(ref CSX `a`, const CSX `b`);
  Merge `b` flow analysis results into `a`.
  Parameters:

  CSX `a` | the path to merge `b` into
  CSX `b` | the other path

  Returns:
  false means either `a` or `b` skips initialization

Copyright © 1999-2019 by the D Language Foundation | Page generated by Ddoc on Sat Mar 2 03:26:35 2019